import Assignment9.Kelvin.kel2cel

import scala.language.implicitConversions


package object Assignment9 {
  sealed trait Temperature {
  }

  object Temperature {
    implicit def cel2kel(celsius: Celsius): Kelvin = new Kelvin(celsius.value + 273.15)
    implicit def kel2cel(kelvin: Kelvin): Celsius = new Celsius(kelvin.value - 273.15)
  }

  case class Celsius(value: Double) extends Temperature {
    override def toString: String = s"$value°C"
  }
  object Celsius {
    implicit def val2cel(value: Double): Celsius = new Celsius(value)
  }

  case class Kelvin(value: Double) extends Temperature {
    override def toString: String = s"$value K"
  }
  object Kelvin {
    implicit def kel2cel(value: Double): Kelvin = new Kelvin(value)

  }
}
